Codeforces 599 C. Day at the Beach

点击打开链接

C. Day at the Beach

time limit per test
2 seconds

memory limit per test
256 megabytes

input
standard input

output
standard output

One day Squidward, Spongebob and Patrick decided to go to the beach. Unfortunately, the weather was bad, so the friends were unable to ride waves. However, they decided to spent their time building sand castles.

At the end of the day there were n castles built by friends. Castles are numbered from 1 to n,
and the height of the i-th castle is equal tohi.
When friends were about to leave, Squidward noticed, that castles are not ordered by their height, and this looks ugly. Now friends are going to reorder the castles in a way to obtain that condition hi ≤ hi + 1 holds
for all i from 1 to n - 1.

Squidward suggested the following process of sorting castles:

  • Castles are split into blocks — groups of consecutive castles. Therefore the block from i to j will
    include castles i, i + 1, ..., j. A block may consist of a single castle.
  • The partitioning is chosen in such a way that every castle is a part of exactly one block.
  • Each block is sorted independently from other blocks, that is the sequence hi, hi + 1, ..., hj becomes
    sorted.
  • The partitioning should satisfy the condition that after each block is sorted, the sequence hi becomes
    sorted too. This may always be achieved by saying that the whole sequence is a single block.

Even Patrick understands that increasing the number of blocks in partitioning will ease the sorting process. Now friends ask you to count the maximum possible number of blocks in a partitioning that satisfies all the above requirements.

Input

The first line of the input contains a single integer n (1 ≤ n ≤ 100 000) —
the number of castles Spongebob, Patrick and Squidward made from sand during the day.

The next line contains n integers hi (1 ≤ hi ≤ 109).
The i-th of these integers corresponds to the height of the i-th
castle.

Output

Print the maximum possible number of blocks in a valid partitioning.

Sample test(s)

input

3
1 2 3

output

3

input

4
2 1 3 2

output

2

Note

In the first sample the partitioning looks like that: [1][2][3].


In the second sample the partitioning is: [2, 1][3, 2]

题目大意:

给你 n 个数 arr[i],让你将这 n 个数分成 从小到大的顺序,看可以分成几块,当然,每个块中的可以排序。。。

样例解释:

3

1 2 3

可以分成 1      2
3三块,拍完许之后是从小到大的。。

解体思路:

将从 0 到 n-1 的每个dp值算出来,咋算呢,dp值就是从 i 到 n-1的最小值。。。

但是不要采用 两个 for 的算法容易超时,所以直接采用从后往前的算法,前边的每一个dp值分别跟 自己比,取最小的那一个。。

上代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <queue>
#include <algorithm>
#include <set>
using namespace std;

#define MM(a) memset(a,0,sizeof(a))

typedef long long LL;
typedef unsigned long long ULL;
const int maxn = 1e5+5;
const int mod = 1e9+7;
const double eps = 1e-8;
const int INF = 0x3f3f3f3f;
LL gcd(LL a, LL b)
{
    if(b == 0)
        return a;
    return gcd(b, a%b);
}
int arr[maxn];
int dp[maxn];
int main()
{
    int n;
    while(~scanf("%d",&n))
    {
        MM(dp);
        MM(arr);
        for(int i=0; i<n; i++)
            scanf("%d",&arr[i]);
        dp[n-1] = arr[n-1];
        for(int i=n-2; i>=0; i--)
        {
            dp[i] = arr[i];
            dp[i] = min(dp[i], dp[i+1]);
        }
        int ans = 1, Max = -INF;
        for(int i=0; i<n; i++)
        {
            Max = max(Max, arr[i]);
            if(dp[i+1] >= Max)
                ans++;
        }
        cout<<ans<<endl;
    }
    return 0;
}
时间: 2024-09-07 14:10:11

Codeforces 599 C. Day at the Beach的相关文章

Codeforces 599 A. Patrick and Shopping

A. Patrick and Shopping time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output Today Patrick waits for a visit from his friend Spongebob. To prepare for the visit, Patrick needs to buy some goodie

Codeforces Round #157 (Div. 1) C. Little Elephant and LCM (数学、dp)

C. Little Elephant and LCM time limit per test 4 seconds memory limit per test 256 megabytes input standard input output standard output The Little Elephant loves the LCM (least common multiple) operation of a non-empty set of positive integers. The

Codeforces B. Taxi 算法题解

简单总结题意: 有一个数组,数组中的数值不会大于4,即只能是1,2,3,4,要把这些数值装进一个容量最大为4的容器里面,使得所用到这样的容器的个数最小. 经测试数据很大,会有10万个数据,所以这里我并不用排序数据,而是使用counting sort的思想,根据特定的数据优化,使得题解时间复杂度为O(n). 更多精彩内容:http://www.bianceng.cnhttp://www.bianceng.cn/Programming/sjjg/ 程序如下: #include <iostream>

CodeForces 233B Non-square Equation

链接: http://codeforces.com/problemset/problem/233/B 题目: B. Non-square Equation time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output Let's consider equation: x2+s(x)·x-n=0, where x,n are positive

CodeForces:200C: Football Championship

地址链接: CF:  http://codeforces.com/problemset/problem/200/C HUST Virtual Judge: http://acm.hust.edu.cn:8080/judge/problem/viewProblem.action?id=28923 题目: C. Football Championship time limit per test 2 seconds memory limit per test 256 megabytes input s

Codeforces Round #205 (Div. 2) / 353C Find Maximum (贪心)

Valera has array a, consisting of n integers a0,a1,...,an-1, and function f(x), taking an integer from 0 to 2n-1 as its single argument. Value f(x) is calculated by formula , where value bit(i) equals one if the binary representation of number xconta

Codeforces Round #201 (Div. 1) / 346A Alice and Bob:数论&amp;amp;想法题

A. Alice and Bob http://codeforces.com/problemset/problem/346/A time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output It is so boring in the summer holiday, isn't it? So Alice and Bob have inven

算法:CodeForces #196(Div. 2) 337D Book of Evil(树形dp)

题意 给一棵n个结点的树,任意两个节点的距离是指连接两点的最短的边数 在树上的某个结点 有一个"恶魔之书",这本书会让距离它d以内的节点都受到影响 已知有m个节点收到了影响,问最多有几 个结点可能放着"恶魔之书"? 思路 要判断某个点是不是放着书,就要判断这个点的周围d距离以 内是否包含所有受影响的m节点 而如果某个节点距离最远的那个受影响节点的距离是L,如果L <= d,那 么说明所有受影响的m节点都在d以内,就可判断这个点可能放着书 那么,我们只要能够求出

Codeforces Round #100 / 140A:简单几何

http://codeforces.com/contest/140/problem/A 过大圆圆心作小圆切线即可发现规律,详见代码. 注意判相等一定要用fabs!!! 完整代码: /*30ms,0KB*/ #include<bits/stdc++.h> using namespace std; int main() { int n, R, r; double a; scanf("%d%d%d", &n, &R, &r); if (r > R |